<?php

$FmtPV['$Keywords']  = '@$page["keywords"]';

#### inline markups ####
## small abbreviations `ABBR
Markup('`abbr','inline',
    "/`([[:upper:]][-[:upper:]0-9]*)([[:lower:]])?\\b([.\/]?$NamePattern)?/",
    "tbabbrHelper");
function tbabbrHelper($m) { return
    $m[3] ? (ProbablyAnAbbreviation($m[2].$m[3]) ?
      '<tbook:visual markup="sc">'.strtolower($m[1].$m[3]).'</tbook:visual>' 
                                                 : $m[0])
          : '<tbook:visual markup="sc">'.strtolower($m[1]).'</tbook:visual>'.$m[2];
}

## '/cite/'
Markup("'/","<'''''","/'\/(.*?)\/'/",
    '<tbook:visual markup="sl">$1</tbook:visual>');

## '@keyboard@'
Markup("'@","<'''''","/'@(.*?)@'/",
    '<tbook:visual markup=\'sw\'>$1</tbook:visual>');

## marginal notes
Markup("{=",'inline',"/{=(.*?)(?:\|\s*(.*?))?=}/",
    '<tbook:mnote>$1</tbook:mnote>');

## highlight text
Markup("{*",'inline',"/{\*(.*?)\*}/",
    '<tbook:visual markup=\'hl\'>$1</tbook:visual>');

## ';small caps;'
Markup("';","<'''''","/';(.*?);'/",
    '<tbook:visual markup=\'sc\'>$1</tbook:visual>');

## nicer em dashes
Markup("s--s",'>squo',"/\s+(&mdash;)(\s+|$)/","tbmdashHelper");
function tbmdashHelper($m) {
  return '&hairsp;'.$m[1].($m[2] ? '&hairsp;' : '');
}
Markup("mm",'>--',"/([^-!;])----([^-&>]|$)/",'$1&dmd;$2');

## tidier spacing
Markup("e.g.",'inline',"/([ie]\.[eg]\.)\s/",'$1&sp;');
Markup(".`s",'<`s',"/\.`\s/",'.&sp;');
Markup("a...a",'<...',"/([^\s])\.\.\.([^\s])/",'$1&mellip;$2');

## LaTeX entity ligatures
Markup('latex', "<'^", '/([`\/])?\\b(La[Tt]e[Xx])\\b/', "tblatexHelper");
function tblatexHelper($m) {
  return ($m[1]=='/') ? $m[1].$m[2] : Keep('&LaTeX;');
}

Markup('tech', "<'^", '/(\\/)?\\bTeX([[:lower:]])?/', "tbtechHelper");
function tbtechHelper($m) {
  return $m[1] ? $m[1].'TeX'.$m[2] : Keep('&TeX;'.$m[2]);
}

Markup('bibtex', "<'^", '/(\\/)?\\b(Bib[Tt]e[Xx])\\b/', "tbbibtexHelper");
function tbbibtexHelper($m) {
  return $m[1] ? $m[1].$m[2] : "B';ib;'".Keep('&TeX;');
}

$EnableTitleLatex = true;

## letter markup
$LetterSignedChar = '062';
if ($_GET['ptype']=='letter') {
  $LetterMarkupStyles = array(
    'S' => '%id=subject apply=block%(:nolinebreaks:)',
    'Y' => '%id=closing apply=block%(:linebreaks:)',
    'C' => '%id=copy apply=block%');
  Markup('addressee','<letter','/^(:?L:)(.*?)$/',
    '$1<tbook:wrap>$2</tbook:wrap>');
  Markup_e('countersign', '<letter', '/^:?N([QA]):/',
    "SetPrintCountersignFmt(\$pagename,\$m[1])");
function SetPrintCountersignFmt($pagename,$type) {
  $GLOBALS['PrintCountersignFmt'] = TranslateCountersign($pagename,$type);
  return 'N:';
}
  $MarkupFrameBase['posteval']['letter'] =
  "\$out = preg_replace_callback('/<tbook:p\s+[^>]*id=\'".
      "(letter|address|subject|opening|closing|name|copy|location|phone)".
      "\'>(.*?)\n<\/tbook:p>/s', \"LetterElements\", \$out);";
function LetterElements($m) {
  $type = $m[1]; $text = $m[2];
  $Preserve = array('letter', 'address', 'location', 'phone');
  $Elements = array(
    'letter'  => 'PrintToAddressFmt',
    'address' => 'PrintFromAddressFmt',
    'subject' => 'PrintHeaderFmt',
    'opening' => 'ActDescription',
    'closing' => 'PrintSubTitleFmt',
    'name'    => 'PrintNameFmt',
    'copy'    => 'PrintCCFmt',
    'location'=> 'PrintLocationFmt',
    'phone'   => 'PrintTelephoneFmt');
  $text = str_replace(array('tbook:','<span','</span'),
                      array('',      '<wrap','</wrap'),$text);
  if (in_array($type, $Preserve))
      SDV($GLOBALS[$Elements[$type]], $text);
  else
      $GLOBALS[$Elements[$type]] = $text;
  return '';
}
} else {
  $LetterMarkupStyles = array(
    'R' => '%right apply=block%(:linebreaks:)',
    'D' => '-&lt;Dear ',
    'Y' => ':'.$LetterSignedChar.':%class=signed apply=block%');
}

## Z; dropcaps markup
Markup('A;','block','/^([[:upper:]]);(([^;&]*(&[^;]+;)*)*);(.*)$/',
  '<:block><tbook:p skip="big"><tbook:lettrine initial=\'$1\'>$2</tbook:lettrine>$5</tbook:p>');

## [^footnote text^] and [^#^] to list footnotes
Markup("[^",'>links','/\[\^(.*?)\^\]/','<tbook:footnote>$1</tbook:footnote>');
Markup("^[^",'<[^','/^\[\^#\^\]$/','');
Markup('fn.','>style','/(<tbook:footnote>.*?<\/tbook:footnote>)(.)/',
  "tbfootnoteHelper");
function tbfootnoteHelper($m) {
  return strstr('.,;:?!',$m[2]) ? $m[2].$m[1] : $m[1].$m[2];
}

## figure captions
Markup('fig','<links',
"/^=figure\s+((?:\[\[)?.*?$ImgExtPattern\"([^\"]*)\"(?:\]\])?)\s*(.*?)$/",
    "tbfigHelper");
function tbfigHelper($m) {
  return '<:block><tbook:figure>'.$m[1].'<tbook:caption>'.
    ($m[3] ? $m[3] : $m[2]).'</tbook:caption></tbook:figure>';
}

## =| centred images and text
Markup('^=|img', '<block',
  "/^=\\|((?>(\\s+|%[A-Za-z][-,.=:#\\w\\s'\"]*%)*))($KeepToken(\\d+L)$KeepToken)(.*)$/",
  "tbcimgHelper");
function tbcimgHelper($m) {
  return (strpos($GLOBALS['KPV'][$m[4]],'<tbook:graphics')===false) ? $m[0] :
    '<:block><tbook:p skip="big" align="center">'.
    $m[1].$m[3].PseudoImgCaption($m[5]).'</tbook:p>';
}
function PseudoImgCaption($text) {
  preg_match('/^(?:\\s*tbook:caption="([^"]+)")?\\s*(.*?)(%%)?$/', $text, $match);
  list($capstr, $cap, $txt, $sty) = $match;
  $open = "<tbook:newline/><tbook:visual markup='small'>";  $close = "</tbook:visual>";
  return ($cap ? "$open$cap$close" : '').($txt ? "$open$txt$close" : '').$sty;
}

Markup('^=|', 'block', '/^=([?|])(.*)$/', "tbcentreHelper");
function tbcentreHelper($m) {
  return '<:block><tbook:p '.(($m[1]=='|') ? 'align="center"' : 'skip="if"').
    '>'.$m[2].'</tbook:p>';
}

## !run-in heads!and text
Markup('^!!', 'inline', '/^!([^!]+?)([.:?])?!(.*?)$/', "tbruninHelper");
function tbruninHelper($m) {
  return '<:block><tbook:h level="4">'.$m[1].
    ($m[2] ? $m[2] : '.').'</tbook:h><tbook:p>'.$m[3].'</tbook:p>';
}

## aphorisms
Markup('^;;', 'block', '/^;([^;]*);(.*?)$/', "tbaphorismHelper");
function tbaphorismHelper($m) {
  if (preg_match('/(&[^\s]+)$/',$m[1])) {
      $m[1] .= ';';
      $aph = preg_replace('/(&[^;]+);/',"$1<>",$m[2]);
      if (preg_match('/^([^;]*);\s*(.*?)$/',$aph,$match)) {
          $m[1] .= str_replace('<>',';',$match[1]);
          $m[2]  = str_replace('<>',';',$match[2]);
      }   
  }
  return '<:block><tbook:blockquote'.
  ($m[1] ? ' class="aphorism"><tbook:caption>'.$m[1].'</tbook:caption' : '').
   '><tbook:p><tbook:quote class="pull">'.$m[2].
   '</tbook:quote></tbook:p></tbook:blockquote>';
}

## :+ for multiple <dd> per <dt> and multipar item lists
Markup(':+:', '<^::', '/^(:+.*?:)((?:.*?:\+.*?)+)$/', "tbitemHelper");
Markup(':+*', '<^*',  '/^([#*]+)((?:.*?:\+.*?)+)$/',  "tbitemHelper");
function tbitemHelper($m) {
#  return $m[1].'<tbook:p>'.str_replace(':+','</tbook:p><tbook:p>',$m[2]).'</tbook:p>';
  return $m[1].'<tbook:multipar>'.str_replace(':+',' * ',$m[2]).'</tbook:multipar>';
}

Markup(':+P','>:+*','/:\+/','<tbook:newline/><tbook:hspace dim="*1.5em" />');

## equations using latexrender
$tbLatexrender = true;
Markup_e('eqref','>latexr','/(E[Qq])\(([A-Za-z][-.:\\w]*)\)([)\s])?/',
    "Keep(TBFigureRef(\$pagename,\$m[1],\$m[2],\$m[3]),'L')");


## section references (requires pagetoc for pre-processing)
Markup_e('secref2','inline',
    '/(`)?(SEC|Sec)\(\s+([A-Za-z][-.:\\w]*)\s+\)([)\s])?/',
    "Keep(TBFigureRef(\$pagename,\$m[2],\$m[3],\$m[4],\$m[1]),'L')");


## figure and table references
SDV($ReferencePrefixFmt, array('EQ' => '$[equation]', 'FIG' => '$[figure]', 
         'TAB' => '$[table]', 'DIV' => '$[excerpt]',  'SEC' => '$[section]'));
SDV($ReferencePageNumbers, false);
$FigureReferenceFmt  = '<tbook:ref refid="$LinkID">$LinkText</tbook:ref>';
$FigureVReferenceFmt = '<tbook:vref refid="$LinkID">$LinkText</tbook:vref>';
$FigurePReferenceFmt = $FigureReferenceFmt.'<tbook:vpageref refid="$LinkID" />';
$FigureTReferenceFmt = '<tbook:em>$LinkText</tbook:em>';
Markup_e('figref','inline',
    '/(`)?(FIG|Fig|TAB|Tab|DIV|Div)\(([A-Za-z][-.:\\w]*)\)([)\s])?/',
    "Keep(TBFigureRef(\$pagename,\$m[2],\$m[3],\$m[4],\$m[1]),'L')");
Markup('cfloat', '<table','/^(\(:div.*?)\ssummary="([^"]*)"(.*?:\))\s*$/',
  '$1$3<tbook:caption>$2</tbook:caption>');
Markup('markupid','>restore',
  '/(><tbook:caption>|\ssummary=")([^\|\s"<]*?)\|/',' id="$2"$1');

function TBFigureRef($pagename, $kind, $id, $punc='', $esc='') {
  global $ReferencePrefixFmt, $FigureReferenceFmt, $ReferenceList,
    $FigureVReferenceFmt, $FigurePReferenceFmt, $ReferencePageNumbers,
    $FigureTReferenceFmt;
  $ref = (isset($ReferenceList[$id]) ? ', '.
         str_replace('$LinkText', $ReferenceList[$id], $FigureTReferenceFmt).
         (($punc==' ') ? ',' : '') : '').$punc;
  if ($esc)
      $fmt = $FigureReferenceFmt;
  elseif ($ReferencePageNumbers) 
      $fmt = ($punc==' ') ? $FigureVReferenceFmt : 
            (($punc==')') ? $FigureReferenceFmt  : $FigurePReferenceFmt);
  else
      $fmt = $FigureReferenceFmt;
  if (strstr('FigTabEqDivSec', $kind)) {
      $kind = strtoupper($kind);
      $txt = FmtPageName($ReferencePrefixFmt[$kind], $pagename);
      $txt[0] = strtoupper($txt[0]);
  } else
      $txt = FmtPageName($ReferencePrefixFmt[$kind], $pagename);
  return str_replace(array('$LinkID','$LinkText'), array($id,$txt), $fmt).$ref;
}

## (:markup:) that excludes heading markup examples
function TbookHMarkupMarkup($m) {
  $lead  = $m[1];
  $texta = str_replace('`.','',$m[3]);
  $textb = $m[3];
  return "$lead<:block>" .
    Keep("<tbook:group class='frame'><tbook:verbatim>" . wordwrap($texta, 70) . 
    "</tbook:verbatim><tbook:hr style='dotted' />") .
    "\n$textb\n(:divend:)</tbook:group>\n";
}
Markup('`markup','<markup',
  "/(^|\\(:nl:\\))\\(:markup:\\)[^\\S\n]*\\[([=@])((?:\n`\\.!+.*?)+)\\2\\]/sim",
  "TbookHMarkupMarkup");

## (:notice:) markup for conditional notices
$Conditions['exists'] = "MultiPageExists(\$condparm,\$pagename)";
Markup('notice', 'block', '/^\(:notice\s+(.*?)\s*:\)$/',
    "<:block><tbook:notice kind='$1'>");
Markup('noticeend', 'block', '/^\(:noticeend:\)$/', "<:block></tbook:notice>");

function MultiPageExists($args, $pagename) {
  foreach(explode(' ', $args) as $v)
    if (PageExists(FmtPageName($v, $pagename))) return true;
  return false;
}

?>
